﻿//DESCRIPTION:© Cari Jansen - Script to set plurals  

/* ------------------------------------------------------------------
   Script Description :  Amend document text based on found strings
                                                  
                         Tested with version 4.0.4 InDesign CS2 (Mac)

   Script usage:      :  Replaces singular strings with plural in previous
                         paragraph when text found with 'and' that
                         is formatted using a particular style.
   							  
   Script name        :  MakePlural_v1.jsx
   Script revision    :  1.0
   Script Date        :  created       : 15/08/2006
                         last modified : 16/08/2006

   Script development :  Cari Jansen
                         www.carijansen.com
                              
                         Note: Some error handlers included.
                               
                         This script maybe freely distributed and modified
                         with full attribution.
                         
  Acknowledgements:  Thank you to David Saunders for his generous sharing
                     of scripting knowledge (www.jsid.blogspot.com) and
                     Adobe Forums (www.adobe.com/support/forums) and to
                     many others sharing their Scripting knowledge publicly
                     on forums.
                     A special thank you to Peter Kahrel for pointing me 
                     in the right direction for this script @ Adobe Forums.
//   ------------------------------------------------------------------- */ 

doDocOpenCheck();
var myDoc = app.activeDocument;

doStorySelectedCheck(); 
var myStory = myDoc.selection[0].parentStory

// Find Strings defined
var myFindString1 = "and"; // or any other string you are searching for.

/* to add more search strings, simply type:
   var myFindString2 =",";  (for searching for commas)
   var myFindString3 ="yoursearchstring"; etc.

   To perform multiple of these searches whilst running the script
   once, add more FindString and Change searches.
   To do this: Copy the 4 lines of code below "FindString and Change searches"
   and paste.
   remove the "var" in front of myFindParaStyle for those additional searches.
   E.g.
    myClearFindChange(); 
    myFindParaStyle = myDoc.paragraphStyles.item("Your Paragraph Style name"); // change to your paragraph style name
    myFindString = myFindString2;  // set this to your other FindStrings.
    doFindChange(myFindString, myFindParaStyle);  

*/

// FindString and Change searches
    myClearFindChange(); 
var myFindParaStyle = myDoc.paragraphStyles.item("Your Paragraph Style name"); // change to your paragraph style name
    myFindString = myFindString1;
    doFindChange(myFindString, myFindParaStyle);  

// END SCRIPT CODE ----------------------------------------------------------

// FUNCTIONS ----------------------------------------------------------------


// --- start function 'doDocOpenCheck' ----------------------------------------
function doDocOpenCheck() {
	if (app.documents.length ==0){
		// error message call
		alert ("Error: No Document open. \nPlease open a document and try again");
		exit(0);
	}
}
// --- end function ---------------------------------------------------------

// --- start function 'doFindChange' ----------------------------------------
function doFindChange(myFindString, myFindParaStyle)
{  
  var i=0 
   myFindAction = myStory.search(myFindString, true, true, undefined, {appliedParagraphStyle:myFindParaStyle},undefined);

   while(i < myFindAction.length) { 
      var prevPar = myStory.paragraphs.previousItem(myFindAction[i].paragraphs[0]); 
      prevPar.insertionPoints[-2].contents = "s"; 
       i++;
   }
}
// --- end function ---------------------------------------------------------

// --- start function 'doStorySelectedCheck' --------------------------------
function doStorySelectedCheck() {
	if (app.selection.length == 0) {
		//if (app.selection[0].constructor.name != "TextFrame"){
		//// error message call
		alert ("Error: Nothing Selected selected. \nPlease select text frame and try again");
		exit(0);
		//}
	}
	if (app.selection[0].constructor.name != "TextFrame") {
		//// error message call
		alert ("Error: Selection is not a text frame. \nPlease select text frame and try again");
		exit(0);
	}
}
// --- end function ---------------------------------------------------------

// --- start function 'myClearFindChange' -----------------------------------
function myClearFindChange(){ 
	app.findPreferences   = NothingEnum.nothing; 
	app.changePreferences = NothingEnum.nothing;	 
}
// --- end function ---------------------------------------------------------